Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Private Declare Function GetDC Lib "user32" (ByVal hWnd As _
        Long) As Long
        
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd _
        As Long, ByVal hDC As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" _
        (ByVal hDC As Long) As Long
        
Private Declare Function CreateDIBSection Lib "gdi32" _
        (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, _
        ByVal un As Long, ByVal lplpVoid As Long, ByVal _
        handle As Long, ByVal dw As Long) As Long
        
Private Declare Function GetDIBits Lib "gdi32" (ByVal _
        aHDC As Long, ByVal hBitmap As Long, ByVal _
        nStartScan As Long, ByVal nNumScans As Long, lpBits _
        As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) _
        As Long
        
Private Declare Function SetDIBitsToDevice Lib "gdi32" _
        (ByVal hDC As Long, ByVal x As Long, ByVal y As _
        Long, ByVal dx As Long, ByVal dy As Long, ByVal _
        SrcX As Long, ByVal SrcY As Long, ByVal Scan As _
        Long, ByVal NumScans As Long, Bits As Any, _
        BitsInfo As BITMAPINFO, ByVal wUsage As Long) _
        As Long
        
Private Declare Function SelectObject Lib "gdi32" (ByVal _
        hDC As Long, ByVal hObject As Long) As Long
        
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC _
        As Long) As Long
        
Private Declare Function DeleteObject Lib "gdi32" (ByVal _
        hObject As Long) As Long
        
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC _
       As Long, ByVal x As Long, ByVal y As Long, ByVal _
       nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC _
       As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
       ByVal dwRop As Long) As Long
        
Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Private Const BI_RGB As Long = 0&
Private Const DIB_RGB_COLORS As Long = 0&

Public Type WATCHRECTTYPE
    Src_hWnd As Long
    Dest_hWnd As Long
    Left As Long
    Top As Long
    Width As Long
    Height As Long
End Type

Public Blend(0 To 255, 0 To 2) As Byte

Dim iBitmap As Long
Dim iDC As Long
Dim bi24BitInfo As BITMAPINFO
Dim WR As WATCHRECTTYPE

'Erzeugt eine DIB
Public Sub InitDBI(WatchRect As WATCHRECTTYPE, _
                   Field1() As Byte, Field2() As Byte)
    Dim Width As Long, hDC As Long
    
    WR = WatchRect
    
    'Anpassung der Weite. Die in bi24BitInfo.bmiHeader
    'angegebene Weite muss glatt durch 4 teilbar sein.
    'Anderfalls kommt es zum Absturz. Vermutlich hat
    'dies etwas mit der eingestellten Auflsung zu tuen.
    Width = (WR.Width \ 4) * 4 + 4
    
    'Bitmap-Header
    With bi24BitInfo.bmiHeader
        .biBitCount = 24
        .biCompression = BI_RGB
        .biPlanes = 1
        .biSize = Len(bi24BitInfo.bmiHeader)
        .biWidth = Width
        .biHeight = WR.Height + 1
    End With
     
    'ByteArrays in der erfroderlichen Gre anlegen
    ReDim Field1(0 To bi24BitInfo.bmiHeader.biWidth * 3 - 1, _
                 0 To bi24BitInfo.bmiHeader.biHeight - 1)
    
    ReDim Field2(0 To bi24BitInfo.bmiHeader.biWidth * 3 - 1, _
                 0 To bi24BitInfo.bmiHeader.biHeight - 1)
                
    'hDC des Ziel-Fensters ermitteln
    hDC = GetDC(WR.Dest_hWnd)
    
    'kompatiblen hDC fr die DIB erstellen
    iDC = CreateCompatibleDC(hDC)
    
    'Ziel hDC wieder freigeben
    Call ReleaseDC(WR.Dest_hWnd, hDC)
    
    'Gertekontextunabhngige Bitmap (DIB) erzeugen
    iBitmap = CreateDIBSection(iDC, bi24BitInfo, _
              DIB_RGB_COLORS, ByVal 0&, ByVal 0&, ByVal 0&)
    
    'iBitmap in den neuen DIB-DC whlen
    Call SelectObject(iDC, iBitmap)
End Sub

'Kopiert eine Grafik aus einem beliebigen DC in den DIB-DC
'und von da aus in ein ByteArray
Public Sub CopyBitmapToArray(Field1() As Byte, Field2() As Byte)
    Dim hDC As Long
    
    'hDC des Quell-Fensters ermitteln
    hDC = GetDC(WR.Src_hWnd)
    
    'hDC des Quell-Fensters in den hDC der DIB kopieren
    Call BitBlt(iDC, 0, 0, bi24BitInfo.bmiHeader.biWidth, _
                bi24BitInfo.bmiHeader.biHeight, hDC, WR.Left, _
                WR.Top, vbSrcCopy)
    
    'Gertekontextunabhngige Bitmap in ByteArrays kopieren
    Call GetDIBits(hDC, iBitmap, 0, _
                   bi24BitInfo.bmiHeader.biHeight, _
                   Field1(0, 0), bi24BitInfo, DIB_RGB_COLORS)
    
    Call GetDIBits(hDC, iBitmap, 0, _
                   bi24BitInfo.bmiHeader.biHeight, _
                   Field2(0, 0), bi24BitInfo, DIB_RGB_COLORS)
    
    'hDC des Quell-Fensters wieder freigeben
    Call ReleaseDC(WR.Src_hWnd, hDC)
End Sub

'RGB Filter auf das Array anwenden
Public Sub CalculateFilterArray(Field1() As Byte, Field2() As Byte)
    Dim x As Long, y As Long
  
    For y = 0 To UBound(Field1, 2)
        For x = 0 To WR.Width * 3 - 1 Step 3
            Field2(x, y) = Blend(Field1(x, y), 2)
            Field2(x + 1, y) = Blend(Field1(x + 1, y), 1)
            Field2(x + 2, y) = Blend(Field1(x + 2, y), 0)
        Next x
    Next y
End Sub

Public Sub WriteArrayTohWnd(Field() As Byte)
    Dim hDC As Long
    
    'hDC des Ziel-Fensters ermitteln
    hDC = GetDC(WR.Dest_hWnd)
    
    'ByteArray in kopieren auf Form kopieren
    Call SetDIBitsToDevice(hDC, WR.Left, WR.Top, WR.Width + 1, _
        bi24BitInfo.bmiHeader.biHeight, 0, 0, 0, _
        bi24BitInfo.bmiHeader.biHeight, Field(0, 0), _
        bi24BitInfo, DIB_RGB_COLORS)
    
    'hDC des Quell-Fensters wieder freigeben
    Call ReleaseDC(WR.Dest_hWnd, hDC)
End Sub

'Erzeugten DIB-DC und die generierte Bitmap wieder aus dem
'Speicher lschen
Public Sub ExitDBI()
    
    'DIB-DC
    Call DeleteDC(iDC)
    
    'Bitmap
    Call DeleteObject(iBitmap)
End Sub


